<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="记录id" prop="recordId">
        <el-input v-model="formData.recordId" placeholder="请输入记录id" />
      </el-form-item>
      <el-form-item label="记录明细id" prop="recordDetailId">
        <el-input v-model="formData.recordDetailId" placeholder="请输入记录明细id" />
      </el-form-item>
      <el-form-item label="计划id" prop="planId">
        <el-input v-model="formData.planId" placeholder="请输入计划id" />
      </el-form-item>
      <el-form-item label="原料id" prop="itemId">
        <el-input v-model="formData.itemId" placeholder="请输入原料id" />
      </el-form-item>
      <el-form-item label="重量" prop="weight">
        <el-input v-model="formData.weight" placeholder="请输入重量" />
      </el-form-item>
      <el-form-item label="单位" prop="unitId">
        <el-input v-model="formData.unitId" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="记录人" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入记录人" />
      </el-form-item>
      <el-form-item label="投料时间" prop="feedingTime">
        <el-date-picker
          v-model="formData.feedingTime"
          type="date"
          value-format="x"
          placeholder="选择投料时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { FeedingRecordPlanApi, FeedingRecordPlanVO } from '@/api/mes/feedingplan'

/** 投料分配计划 表单 */
defineOptions({ name: 'FeedingRecordPlanForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  recordId: undefined,
  recordDetailId: undefined,
  planId: undefined,
  itemId: undefined,
  weight: undefined,
  unitId: undefined,
  userId: undefined,
  feedingTime: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FeedingRecordPlanApi.getFeedingRecordPlan(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as FeedingRecordPlanVO
    if (formType.value === 'create') {
      await FeedingRecordPlanApi.createFeedingRecordPlan(data)
      message.success(t('common.createSuccess'))
    } else {
      await FeedingRecordPlanApi.updateFeedingRecordPlan(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    recordId: undefined,
    recordDetailId: undefined,
    planId: undefined,
    itemId: undefined,
    weight: undefined,
    unitId: undefined,
    userId: undefined,
    feedingTime: undefined,
  }
  formRef.value?.resetFields()
}
</script>